<?php if (!defined('PmWiki')) exit();
/**
 * themes.php
 * @author V.Krishn (vkrishn@insteps.net), Copyright 2005-2023
 * @note This file is part of Cookbook recipe "Phplm" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 * @package phplm
 */

function phplm_set_theme($menuID, $menutype, $theme='default', $themeonly=0) {
  $phpmenuTheme = array();
  $phpmenuTheme['MenuID'] = $menuID;
  $phpmenuTheme['Theme'] = $theme;
  // ========= common path properties ========
  global $Phplm, $lmMenuThemes, $lmTreeThemes;

  $lmThemes = array_merge((array)$lmMenuThemes, (array)$lmTreeThemes);
  $lmInstallDir = &$Phplm['Current']['dir'];
  $lmInstallUrl = &$Phplm['Install']['dirUrl'];
  $lmInstallUrlPath = &$Phplm['Install']['dirUrlPath'];
  $lmIconDir = &$Phplm['Install']['icon']['dirFmt'];
  $lmIconUrl = &$Phplm['Install']['icon']['dirUrl'];

  $phpmenuTheme['DirPath']      = "$lmInstallDir/";
  //$phpmenuTheme['WwwPath']    = "$lmInstallUrl/"; //absolute
  $phpmenuTheme['WwwPath']      = "$lmInstallUrlPath/"; //relative

  //$phpmenuTheme['setDirroot'] = "./";
  $phpmenuTheme['setLibjsdir']  = $phpmenuTheme['DirPath']."libjs/";
  $phpmenuTheme['setImgdir']    = $phpmenuTheme['DirPath']."themes/$theme/images/";
  $phpmenuTheme['setImgwww']    = $phpmenuTheme['WwwPath']."themes/$theme/images/";
  $phpmenuTheme['setIcondir']   = $lmIconDir.'/';
  $phpmenuTheme['setIconwww']   = $lmIconUrl.'/';
  $phpmenuTheme['setTpldir']    = $phpmenuTheme['DirPath']."themes/";
  // ========= common path properties ========

  /* - themes for dropdown
         default  galaxy  gtk2  keramik
     - themes for treemenus
         default  galeon  gmc,kde  nautilus  mozilla
     - to do
         gnome   old  plain
  */

  if( ! in_array($phpmenuTheme['Theme'], $lmThemes)) return;
  include($phpmenuTheme['Theme'].'/theme.php');

  if ($themeonly==1) {
    if(isset($phpmenuTheme['Style'])) { return $phpmenuTheme['WwwPath']."themes/".$phpmenuTheme['Style']; }
  }

  $objMenuId = $GLOBALS[$phpmenuTheme['MenuID']];
  /* common properties */
  $temp = array('setImgdir', 'setImgwww', // checks if file exists
                'setIcondir', 'setIconwww',
                'setLibjsdir'  //need to be set
               );
  foreach($temp as $v) { if(isset($phpmenuTheme[$v])) $objMenuId->$v($phpmenuTheme[$v]); }
  if(isset($phpmenuTheme['setIconsize'])) $objMenuId->setIconsize($phpmenuTheme['setIconsize']['w'], $phpmenuTheme['setIconsize']['h']);
  /* common properties */

  if ($menutype!="tree" && $menutype!="phptree") {
    $temp = array('setTpldir', 'setDownArrowImg', 'setForwardArrowImg', // templates , arrow image
                  'setHorizontalMenuTpl', 'setVerticalMenuTpl', 'setSubMenuTpl', // layermenu
                  'setHorizontalPlainMenuTpl', 'setPlainMenuTpl' // plainmenu
                 );
    foreach($temp as $v) { if(isset($phpmenuTheme[$v])) $objMenuId->$v($phpmenuTheme[$v]); }
  }
  
  if ($menutype=="tree") { $objMenuId->setTreeMenuTheme($theme.'_'); }
  if ($menutype=="phptree") { $objMenuId->setPHPTreeMenuTheme($theme.'_'); }
  
  if(isset($phpmenuTheme['Style'])) { $phpmenuThemeStyle =  $phpmenuTheme['WwwPath']."themes/".$phpmenuTheme['Style']; }
  return @$phpmenuThemeStyle;

}

